//*------------------------------------------------------------------*
//|                                            TrendLines Trader.mq4 |
//|                                         Developed by Coders Guru |
//|                                          Copyrighted for Dogulas |
//|                                            http://www.xpworx.com |
//*------------------------------------------------------------------*
#property   copyright   "Dogulas"
#property   link        "http://www.xpworx.com"
#property   description "TrendLines Trader"
#define     Version     "1.7"
#property   version     Version
#property   strict
//*------------------------------------------------------------------*
//Last Modified: 2016.03.24
//*------------------------------------------------------------------*

//*------------------------------------------------------------------*
// INPUTS
//*------------------------------------------------------------------*
enum YN {No,Yes};
//*------------------------------------------------------------------*
enum MM //Money Managment
{
   UseMM, //Use Money Managment
   FixedLots //Fixed Lots
};
//*------------------------------------------------------------------*
enum TLRule //TrendLineRule
{  
   Touch, //Touch Rule
   BreakOut // Break Out Rule
};
//*------------------------------------------------------------------*
enum TT //Trades Type
{
   Ins, //Instant Orders
   Pen //Pending Orders
};
//*------------------------------------------------------------------*
extern 		string  		         General_Settings              = ""; // General Settings 
extern      int                  MagicNumber                         = 45678;
extern      string               Order_Comment                       = "Trend EA";     //Order Comment

extern 		string  		         Trading_Settings              = ""; // Trading Settings 
extern      TT                   TradesType                          = Ins;            //Trades Type
extern      int                  PendingsDistance                    = 5;              //Pending Order Distance
extern      int                  BarsToCheck                         = 10;             //Bars To Check
extern      int                  Slippage                            = 5;

extern 		string  		         Money_Management_Settings     = ""; // Money Management Settings 
extern      MM                   MoneyManagement                     = UseMM;          //Money Management Type
extern      double               LotSize                             = 0.1;            //Lot Size
extern      double               RiskPercentage                      = 1.0;            //Risk Percentage %
extern      YN                   UseTP_SL                            = Yes;            //Use Target & Stop-loss
extern      int                  TakeProfit                          = 100;            //Target
extern      int                  StopLoss                            = 100;            //Stop-loss

extern      YN                   UseTrailStop                        = Yes;             //Use Trailing Stop
extern      int                  TrailStopAt                         = 75;              //Trailing Stop Pips

extern      YN                   UseBreakEven                        = Yes;            //Use Break Even
extern      int                  BreakEvenAt                         = 50;             //Move To Break  Even Signal Pips    
extern      int                  BreakEvenProfit                     = 25;             //Break Even Minimum Profit

extern      int                  BarsToActivate                      = 1;              //Bars to Activate BreakEven/Trail After    

extern 		string  		         Trends_Settings               = ""; // Trend Lines Settings 
extern      TLRule               TrendLineRule                       = BreakOut;    //Trade TrendLine Rule

extern      string               TLine_Buy_Name                      = "TBuy";      //Trend Line Buy Name
extern      string               TLine_Sell_Name                     = "TSell";     //Trend Line Sell Name

extern      string               RTLine_Buy_Name                     = "RBuy";      //RSI Trend Line Buy Name
extern      string               RTLine_Sell_Name                    = "RSell";     //RSI Trend Line Sell Name

extern 		string  		         RSI_Settings                  = ""; // RSI Settings 
extern      int                  RSIPeriod                           = 9;

extern 		string  		         Schedule_Time_Settings        = ""; // Schedule Time Settings 
extern      YN                   UseScheduleTrades                   = No;             //Use Schedule Trades? (Y/N)
extern      int                  Trading_StartTimeHour               = 6;              //Trading Start Time Hour
extern      int                  Trading_StartTimeMinutes            = 30;             //Trading Start Time Minutes
extern      int                  Trading_EndTimeHour                 = 18;             //Trading End Time Hour
extern      int                  Trading_EndTimeMinutes              = 0;              //Trading End Time Minutes

extern      YN                   CloseOnWeekEnd                      = No;             //Close All On Weekend
extern      ENUM_DAY_OF_WEEK     DayToCloseAll                       = FRIDAY;         //Day To Close All Trades
extern      int                  All_CloseTimeHour                   = 18;             //Weekend Close Time Hour
extern      int                  All_CloseTimeMinutes                = 0;              //Weekend Close Time Minutes

extern 		string  		         Button_Settings               = ""; // CloseAll Button Settings 
extern      YN                   CloseAll_On                         = Yes;            //Show CloseAll Button
extern      color                ButtonBC                            = clrDodgerBlue;  //Button Back Color
extern      color                ButtonFC                            = clrWhite;       //Button Font Color
extern      int                  ButtonX                             = 10;             //Button X Position   
extern      int                  ButtonY                             = 30;            //Button Y Position
//*------------------------------------------------------------------*
// GLOBAL VARIABLES
//*------------------------------------------------------------------*
double mPoint              = 0.0001;
YN     ECN_Broker          = Yes;
bool   TradeAllowed        = true;
double Lots                = 0.1;
//*------------------------------------------------------------------*
bool TL_Found_Buy = false, TL_Found_Sell = false;
double TL_Price_Buy_Cur, TL_Price_Sell_Cur, TL_Price_Buy_Pre, TL_Price_Sell_Pre = 0;

bool RTL_Found_Buy = false, RTL_Found_Sell = false;
double RTL_Price_Buy_Cur, RTL_Price_Sell_Cur, RTL_Price_Buy_Pre, RTL_Price_Sell_Pre;
//*------------------------------------------------------------------*
int TradesCount, LastTradeBar;
datetime LastTradeTime;
datetime AttachTime;
bool     HaveTrades;
//*------------------------------------------------------------------*
int OnInit()
{
   mPoint = GetPoint();
   
   if(CloseAll_On)
   ButtonCreate("CloseAll",ButtonX+10,ButtonY+15,150,40,"Close All Trades",ButtonFC,ButtonBC,clrWhite);
   
   if(!UseTP_SL)
   {
      TakeProfit = 0;
      StopLoss = 0;
   }
   
   return(0);
}
//*------------------------------------------------------------------*
void OnDeinit(const int reason)
{
   DelPrints();
   ButtonDelete(0,"CloseAll");
}
//*------------------------------------------------------------------*
void OnTick()
{

//******************************
// Trade bar
//******************************
   int tb = TrendLineRule; 
  
//******************************
// Detect the TrendLines
//******************************
   DetectTrendLines(tb);
   DetectRSILines(tb);   


//******************************
// Get trades data
//******************************
   GetData();
   
 
//******************************  
// Check for signal
//******************************
   int Signal = CheckForSignal(tb);
   
   
//******************************  
// Close on reversal signal
//******************************
   if(HaveTrades && CloseOnWeekEnd)
   {
      for(int cnt=0; cnt<OrdersTotal(); cnt++)
      {
         if(!OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES)) continue;
         if(OrderMagicNumber()!=MagicNumber) continue;    
     
         //Close On Weekend
         if(CloseOnWeekEnd && TimeDayOfWeek(TimeCurrent())==DayToCloseAll) 
         {
            datetime WeekendClose = FormatTime(All_CloseTimeHour,All_CloseTimeMinutes);
            if(TimeCurrent()>=WeekendClose) if(CloseOrder(OrderTicket())) return;
         }         
      }      
   }
   
//******************************   
// Check Allowed Time
//******************************
   CheckAllowedTime();



//******************************
// Let's trade
//******************************   
   int tick;
   if((LastTradeBar>=BarsToCheck || LastTradeBar==-1) && TradeAllowed)
   {
      //-- Calculate the lots
      if(MoneyManagement==UseMM) Lots = CalcLots(RiskPercentage*0.01,0,AccountEquity());
      else Lots = LotSize;
      
      if(Signal==OP_BUY)
      {
         if(TradesType==Ins)
         {
            tick = OpenInstant(ECN_Broker,Symbol(),OP_BUY,Lots,Slippage,StopLoss,TakeProfit,MagicNumber,Order_Comment);
         }
         else
         {
            tick = OpenPending(Symbol(),High[1]+PendingsDistance*mPoint,OP_BUYSTOP,Lots,0,Slippage,StopLoss,TakeProfit,MagicNumber,Order_Comment);
         }
      }
      if(Signal==OP_SELL)
      {
         if(TradesType==Ins)
         {
            tick = OpenInstant(ECN_Broker,Symbol(),OP_SELL,Lots,Slippage,StopLoss,TakeProfit,MagicNumber,Order_Comment);
         }
         else
         {
            tick = OpenPending(Symbol(),Low[1]-PendingsDistance*mPoint,OP_SELLSTOP,Lots,0,Slippage,StopLoss,TakeProfit,MagicNumber,Order_Comment);
         }
      }
   }
   
   
//******************************   
//-- Trailing stop and Breakeven
//******************************
   if(HaveTrades)
   {
      if(UseTrailStop) SetTrailingStop(TrailStopAt,MagicNumber);
      if(UseBreakEven) SetBreakEven(BreakEvenAt,BreakEvenProfit,MagicNumber);
   }   
 
 
//******************************   
//-- Debug & info
//******************************
   string msg;
   for(int cnt=0; cnt<8; cnt++) msg += "\n";
   msg += "VERSION: " + Version + "\n";
   msg += "--------------------------------\n";
   msg += "Buy Line Detected: " + ts(TL_Found_Buy) + "\n";
   msg += "Sell Line Detected: " + ts(TL_Found_Sell) + "\n";
   msg += "Last Trade Bar: " + ts(LastTradeBar) + "\n";
   //msg += "Have Trades: " + ts(HaveTrades) + "\n";
   Comment(msg);
}
//*------------------------------------------------------------------*
void GetData()
{
   //Reset
   LastTradeTime = 0; 
   LastTradeBar = -1;
 
   for(int cnt=0; cnt<OrdersTotal(); cnt++)
   {
      if(!OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES)) continue;
      if(OrderMagicNumber()!=MagicNumber) continue;
      
      HaveTrades = true;
      
   	if(OrderOpenTime()>LastTradeTime) LastTradeTime=OrderOpenTime();

   } 
   for(int cnt=0; cnt<OrdersHistoryTotal(); cnt++)
   {
      if(!OrderSelect(cnt, SELECT_BY_POS, MODE_HISTORY)) continue;
      if(OrderMagicNumber()!=MagicNumber) continue;      
      
   	if(OrderOpenTime()>LastTradeTime) 
   	{
   	   LastTradeTime=OrderOpenTime();
   	}
   } 
 
   LastTradeBar = iBarShift(NULL,0,LastTradeTime);
}
//*------------------------------------------------------------------*
int CheckForSignal(int tb)
{
   double RSI_Cur = GetRSI(tb);
   double RSI_Pre = GetRSI(tb+1);
   double Close_Cur = Close[tb];
   double Close_Pre = Close[tb+1];
   
   //Trend Lines
   if(TL_Found_Buy)
   {
      if(Close_Cur>TL_Price_Buy_Cur && Close_Pre<TL_Price_Buy_Pre && TL_Price_Buy_Cur!=0 && TL_Price_Buy_Pre!=0)
      return(OP_BUY);
   }
   if(TL_Found_Sell)
   {
      if(Close_Cur<TL_Price_Sell_Cur && Close_Pre>TL_Price_Sell_Pre && TL_Price_Sell_Cur!=0 && TL_Price_Sell_Pre!=0)
      return(OP_SELL);
   }
   
   //RSI Lines
   if(RTL_Found_Buy)
   {
      if(RSI_Cur>RTL_Price_Buy_Cur && RSI_Pre<RTL_Price_Buy_Pre && RTL_Price_Buy_Cur!=0 && RTL_Price_Buy_Pre!=0)
      return(OP_BUY);
   }
   if(RTL_Found_Sell)
   {
      if(RSI_Cur<RTL_Price_Sell_Cur && RSI_Pre>RTL_Price_Sell_Pre && RTL_Price_Sell_Cur!=0 && RTL_Price_Sell_Pre!=0)
      return(OP_SELL);
   }
   
   
   return(-1);
}
//*------------------------------------------------------------------*
double GetRSI(int tb)
{
   return( iRSI(NULL,0,RSIPeriod,PRICE_CLOSE,tb) );
}
//*------------------------------------------------------------------*
void OnChartEvent(const int id, const long &lparam, const double &dparam, const string &sparam)
{
  
   if(sparam=="CloseAll")
   {
      CloseAllFifo(MagicNumber,7);
      ObjectSetInteger(0,"CloseAll",OBJPROP_STATE,false);
   }
}
//*------------------------------------------------------------------*
void DetectTrendLines(int tb)
{
   TL_Found_Buy = false;
   TL_Found_Sell = false;
   TL_Price_Buy_Cur = 0;
   TL_Price_Sell_Cur = 0;
   TL_Price_Buy_Pre = 0;
   TL_Price_Sell_Pre = 0;
   
   
   for(int cnt = 0; cnt < ObjectsTotal(); cnt++)
   {
      string name = ObjectName(cnt);
      
      if(ObjectType(name)==OBJ_TREND)
      {
         if(strstr(name,TLine_Buy_Name)) 
         { 
            TL_Found_Buy = true; 
            TL_Price_Buy_Cur = ObjectGetValueByShift(name,tb); 
            TL_Price_Buy_Pre = ObjectGetValueByShift(name,tb+1);      
         }
      }  
      
      if(ObjectType(name)==OBJ_TREND)
      {
         if(strstr(name,TLine_Sell_Name))
         { 
            TL_Found_Sell = true; 
            TL_Price_Sell_Cur = ObjectGetValueByShift(name,tb); 
            TL_Price_Sell_Pre = ObjectGetValueByShift(name,tb+1); 
         }
      }          
   }
}
//*------------------------------------------------------------------*
void DetectRSILines(int tb)
{
   RTL_Found_Buy = false;
   RTL_Found_Sell = false;
   RTL_Price_Buy_Cur = 0;
   RTL_Price_Sell_Cur = 0;
   RTL_Price_Buy_Pre = 0;
   RTL_Price_Sell_Pre = 0;
   
   
   for(int cnt = 0; cnt < ObjectsTotal(); cnt++)
   {
      string name = ObjectName(cnt);
      
      if(ObjectType(name)==OBJ_TREND)
      {
         if(strstr(name,RTLine_Buy_Name)) 
         { 
            RTL_Found_Buy = true; 
            RTL_Price_Buy_Cur = ObjectGetValueByShift(name,tb); 
            RTL_Price_Buy_Pre = ObjectGetValueByShift(name,tb+1);      
         }
      }  
      
      if(ObjectType(name)==OBJ_TREND)
      {
         if(strstr(name,RTLine_Sell_Name))
         { 
            RTL_Found_Sell = true; 
            RTL_Price_Sell_Cur = ObjectGetValueByShift(name,tb); 
            RTL_Price_Sell_Pre = ObjectGetValueByShift(name,tb+1); 
         }
      }          
   }
}
//*------------------------------------------------------------------*
bool strstr(string data, string what, bool sensitive=false)
{
   if(sensitive) {if(StringFind(data,what,0)>-1) return(true); }
   else { if(StringFind(StringLowerCase(data),StringLowerCase(what),0)>-1) return(true); }
   return(false);
}
//*------------------------------------------------------------------*
string StringLowerCase(string str)
{
   int s = StringLen(str);
   int chr = 0;
   string temp = "";
   for (int c = 0 ; c < s ; c++)
   {
      chr = StringGetChar(str,c);
      if (chr >= 65 && chr <=90) chr = chr + 32;
      temp = temp + CharToStr((uchar)chr);
   }
   return (temp);  
}
//*------------------------------------------------------------------*
bool ButtonCreate(const string            name="Button",            // button name                  
                  const int               x=0,                      // X coordinate
                  const int               y=0,                      // Y coordinate
                  const int               width=50,                 // button width
                  const int               height=18,                // button height                  
                  const string            text="Button",            // text
                  const color             text_clr=clrBlack,        // text color
                  const color             back_clr=clrBlue,         // background color
                  const color             border_clr=clrNONE,       // border color
                  const bool              state=false,              // pressed/released
                  const bool              back=false,               // in the background
                        bool              selection=false,          // highlight to move
                  const bool              hidden=false,             // hidden in the object list
                        long              z_order=1)                // priority for mouse click
{
   ENUM_BORDER_TYPE  border_type = BORDER_FLAT;
   long              chart_ID=0;               // chart's ID
   int               sub_window=0;             // subwindow index
   ENUM_BASE_CORNER  corner=CORNER_LEFT_UPPER; // chart corner for anchoring
   string            font="Arial Bold";        // font
   int               font_size=12;             // font size

   ResetLastError();
   if(!ObjectCreate(chart_ID,name,OBJ_BUTTON,sub_window,0,0))
   {
      Print(__FUNCTION__, ": failed to create the button! Error code = ",GetLastError());
      return(false);
   }

   ObjectSetInteger(chart_ID,name,OBJPROP_XDISTANCE,x);
   ObjectSetInteger(chart_ID,name,OBJPROP_YDISTANCE,y);
   ObjectSetInteger(chart_ID,name,OBJPROP_XSIZE,width);
   ObjectSetInteger(chart_ID,name,OBJPROP_YSIZE,height);
   ObjectSetInteger(chart_ID,name,OBJPROP_CORNER,corner);
   ObjectSetString(chart_ID,name,OBJPROP_TEXT,text);
   ObjectSetString(chart_ID,name,OBJPROP_FONT,font);
   ObjectSetInteger(chart_ID,name,OBJPROP_FONTSIZE,font_size);
   ObjectSetInteger(chart_ID,name,OBJPROP_COLOR,text_clr);
   ObjectSetInteger(chart_ID,name,OBJPROP_BGCOLOR,back_clr);
   ObjectSetInteger(chart_ID,name,OBJPROP_BORDER_COLOR,border_clr);
   ObjectSetInteger(chart_ID,name,OBJPROP_BORDER_TYPE,border_type);   
   ObjectSetInteger(chart_ID,name,OBJPROP_BACK,back);
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTABLE,selection);
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTED,selection);
   ObjectSetInteger(chart_ID,name,OBJPROP_HIDDEN,hidden);
   ObjectSetInteger(chart_ID,name,OBJPROP_ZORDER,z_order);
   return(true);
}
//*------------------------------------------------------------------*
bool ButtonDelete(const long chart_ID, const string name)
{
   if(IsTesting()) return(false);
   ResetLastError();
   if(!ObjectDelete(chart_ID,name))
   {
      Print(__FUNCTION__,": failed to delete the button! Error code = ",GetLastError());
      return(false);
   }
   return(true);
}
//*------------------------------------------------------------------*

//********************************************************************
//
// TIMES FUNCTIONS
//
//********************************************************************
void CheckAllowedTime()
{ 
   TradeAllowed = true;
   
   if(CloseOnWeekEnd && TimeDayOfWeek(TimeCurrent())==DayToCloseAll) 
   {
      datetime WeekendClose = FormatTime(All_CloseTimeHour,All_CloseTimeMinutes);
      if(TimeCurrent()>WeekendClose)
      {
         TradeAllowed = false;
         return;
      }
   }      
        
   if(!UseScheduleTrades) TradeAllowed = true;
   else
   TradeAllowed = ValidTime(Trading_StartTimeHour,Trading_StartTimeMinutes,Trading_EndTimeHour,Trading_EndTimeMinutes);
}
//*------------------------------------------------------------------*
datetime FormatTime(int intHours, int intMinutes, bool Tomorrow=false)
{   
   string strTime, temp_hours, temp_minutes, temp_time;  
    
   if(intMinutes>59) intMinutes = 59;    
   if(intHours>23) intHours = intHours - 23;
   if(intHours<10) temp_hours = "0" + ts(intHours);
   else temp_hours = ts(intHours);   
   if(intMinutes<10) temp_minutes = "0" + ts(intMinutes);
   else temp_minutes = ts(intMinutes);   
   strTime = temp_hours + ":" + temp_minutes;  
   if(Tomorrow)
   temp_time = TimeToStr(iTime(Symbol(),PERIOD_D1,0)+(60*60*24),TIME_DATE) + " " + strTime;  
   else
   temp_time = TimeToStr(iTime(Symbol(),PERIOD_D1,0),TIME_DATE) + " " + strTime;  
   
   return(StrToTime(temp_time));
}
//*------------------------------------------------------------------*
bool ValidTime(int StartTimeHour, int StartTimeMinutes, int EndTimeHour, int EndTimeMinutes)
{
   //disabled
   if(StartTimeHour==0 && StartTimeMinutes==0 && EndTimeHour==0 && EndTimeMinutes==0) return(false);
   
   string TradeStartTime, TradeEndTime;
   //Format Time
   string temp_hours, temp_minutes;   
   if(StartTimeHour>23 || StartTimeMinutes>59) TradeStartTime = "23:59";
   else
   { 
      if(StartTimeHour<10) temp_hours = "0" + IntegerToString(StartTimeHour);
      else temp_hours = IntegerToString(StartTimeHour);   
      if(StartTimeMinutes<10) temp_minutes = "0" + IntegerToString(StartTimeMinutes);
      else temp_minutes = IntegerToString(StartTimeMinutes);   
      TradeStartTime = temp_hours + ":" + temp_minutes;
   }
   if(EndTimeHour>23 || EndTimeMinutes>59) TradeEndTime = "23:59";
   else
   { 
      if(EndTimeHour<10) temp_hours = "0" + IntegerToString(EndTimeHour);
      else temp_hours = IntegerToString(EndTimeHour);   
      if(EndTimeMinutes<10) temp_minutes = "0" + IntegerToString(EndTimeMinutes);
      else temp_minutes = IntegerToString(EndTimeMinutes);   
      TradeEndTime = temp_hours + ":" + temp_minutes;
   }     
   
   string temp_time = "";
   datetime t_start_time, t_end_time;
   
   temp_time = TimeToStr(iTime(Symbol(),PERIOD_D1,0),TIME_DATE) + " " + TradeStartTime;  
   t_start_time = StrToTime(temp_time);
   temp_time = TimeToStr(iTime(Symbol(),PERIOD_D1,0),TIME_DATE) + " " + TradeEndTime;  
   t_end_time = StrToTime(temp_time);
   
   datetime ct = TimeCurrent();
   if(ct >= t_start_time && ct <= t_end_time) return(true);
   return(false);     
}
//********************************************************************


//********************************************************************
//
// PRINTS FUNCTIONS
//
//********************************************************************
string ts(int val) { return(IntegerToString(val)); }
string ts(bool val) { if(val) return("Yes"); return("No");}
string ts(datetime val) { return(TimeToString(val)); }
string ts(double val, int digits=8) { return(DoubleToString(val,digits)); }
//*------------------------------------------------------------------*
void MLP(string title, string value="", int op=0, color clr=Yellow,int print_corner=0)
{
   static int line=0;
   line++;
   if(title=="reset") {line=0; return;} //reset
   if(op==-1) //CLEAR
   {
      DelPrints(true);   
      CPrint(1,1,title,clr);
      CPrint(1,5,value,clr);
      line=0; 
      return;
   } 
   if(StringLen(title)==0) { CPrint(line,1,"",clr); CPrint(line,5,"",clr,print_corner); return;}
   if(StringLen(title)==1) {string t=title; for(int c=0; c<60; c++) title=title+t; CPrint(line,1,title,clr,print_corner); return;}
   
   if(op==1) {if(value==DoubleToStr(OP_BUY,0)) value="Buy"; else if(value==DoubleToStr(OP_SELL,0)) value="Sell"; else value="NA";} //Buy-Sell
   if(op==2) {if(value==DoubleToStr(true,0)) value="Yes"; else value="No";} //Yes-No   
   if(op==3) //remove zeros
   {
      string tmp=value;
      for(int cnt=1;cnt<StringLen(value);cnt++)
      {
         if(StringGetChar(value,StringLen(value)-cnt)==48)
         tmp = StringSubstr(value,0,StringLen(value)-cnt);
         else break;
      }
      if(StringGetChar(tmp,StringLen(tmp)-1)=='.') tmp=tmp+"0";
      value=tmp;
   }   
   if(op==4) value = DoubleToStr(StrToDouble(value),Digits); //digit   
   if(op==5) if(StrToDouble(value)==EMPTY_VALUE) value="Empty"; //EMPTY_VALUE
   else value = DoubleToStr(StrToDouble(value),Digits);
   
   if(print_corner==0)
   {
      CPrint(line,1,title,clr,print_corner);
      CPrint(line,5,value,clr,print_corner);
   }
   else
   {
      CPrint(line,5,title,clr,print_corner);
      CPrint(line,1,value,clr,print_corner);   
   }
}
//*------------------------------------------------------------------*
#define PRT_NAME "CPrint_"
void CPrint(int line,int column,string msg,color font_color=Yellow ,int print_corner=0, int font_size=9, 
string font_name="Arial Bold",int x=15, int y=25 , int xd=40 , int yd=15)
{
   string objName = PRT_NAME + IntegerToString(line) + "_" + IntegerToString(column);
   if(ObjectFind(objName)>-1)
   {
      if(ObjectGetString(0,objName,OBJPROP_TEXT)!=msg || ObjectGetInteger(0,objName,OBJPROP_COLOR)!=font_color)
      {
         ObjectSetText(objName,msg,font_size,font_name,font_color);
         WindowRedraw();
      }
   }
   else
   {
      ObjectCreate(objName,OBJ_LABEL,0,0,0);
      ObjectSetText(objName,msg,font_size,font_name,font_color);
      ObjectSet(objName,OBJPROP_CORNER,print_corner); //Right align
      ObjectSet(objName,OBJPROP_XDISTANCE, x + (column-1)*xd);
      if(line == 1) ObjectSet(objName,OBJPROP_YDISTANCE,y);
      else ObjectSet(objName,OBJPROP_YDISTANCE,y+(yd*(line-1)));
   }
}  
//*------------------------------------------------------------------*
void DelPrints(bool keep_first_line=false)
{
   int cnt;
   if(keep_first_line)
   {
      for(cnt=ObjectsTotal()-1;cnt>=0;cnt--) if(StringFind(ObjectName(cnt),PRT_NAME,0)>-1 && StringFind(ObjectName(cnt),PRT_NAME+"1_",0)==-1)
         ObjectDelete(ObjectName(cnt));
      for(cnt=ObjectsTotal()-1;cnt>=0;cnt--) if(StringFind(ObjectName(cnt),PRT_NAME,0)>-1 && StringFind(ObjectName(cnt),PRT_NAME+"1_",0)==-1)
         ObjectDelete(ObjectName(cnt));
   }
   else
   {
      for(cnt=ObjectsTotal()-1;cnt>=0;cnt--) if(StringFind(ObjectName(cnt),PRT_NAME,0)>-1) ObjectDelete(ObjectName(cnt));
      for(cnt=ObjectsTotal()-1;cnt>=0;cnt--) if(StringFind(ObjectName(cnt),PRT_NAME,0)>-1) ObjectDelete(ObjectName(cnt));
   }
   WindowRedraw();
}
//********************************************************************


//********************************************************************
//
// COMMON FUNCTIONS
//
//********************************************************************
bool NewBar(int ref, int pause=0)
{
   static int BarsRef[10];
   
   if( BarsRef[ref] == 0 || BarsRef[ref]+pause < Bars)
   {
      BarsRef[ref] = Bars;
      return (true);
   }
   return(false);
}
//*------------------------------------------------------------------*
bool TradeExist(int magic, int type = -1)
{
   for(int cnt=0; cnt<OrdersTotal(); cnt++)
   {
      if(!OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES)) continue;
      if(OrderMagicNumber()==magic && (OrderType()==type || type==-1))
      return (true);
    }
    return (false);
}
//*------------------------------------------------------------------*
int GenMagicNumber(string symbol="", bool period=false) //gf-12-07-13
{
   if(symbol=="") symbol=Symbol();
   int magic = 0;   
   string temp = symbol+WindowExpertName();
   for(int c=StringLen(temp)-1; c>=0; c--)
   {
      magic = magic + (StringGetChar(temp,c)*(c+9))*((c+1)*3);      
   }   
   if(period) magic = magic + Period();   
   return(magic);
}
//*------------------------------------------------------------------*
bool isBarTraded(int magic, bool history=true)
{
   for(int cnt=0; cnt<OrdersTotal(); cnt++)
   {
      if(!OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES)) continue;
      if(OrderMagicNumber()!=magic) continue;
      int tb = iBarShift(Symbol(),0,OrderOpenTime(),true);
      if(tb==0) return(true);
   }
   if(history)
   {
      for(int cnt=0; cnt<OrdersHistoryTotal(); cnt++)
      {
         if(!OrderSelect(cnt,SELECT_BY_POS,MODE_HISTORY)) continue;
         if(OrderMagicNumber()!=magic) continue;
         int tb = iBarShift(Symbol(),0,OrderOpenTime(),true);
         if(tb==0) return(true);
      } 
   }
   return (false); 
}
//************************ END OF COMMON FUNCTIONS *******************


//*------------------------------------------------------------------*
//|                                                     xpTrader.mqh |
//|                                         Developed by Coders Guru |
//|                                           Copyrighted for xpWorx |
//|                                            http://www.xpworx.com |
//*------------------------------------------------------------------*
/*#property copyright "xpWorx"
#property link      "http://www.xpworx.com"
#property description "xpTrader - TRADING FUNCTIONS"
#property version     "4.1"*/
//*------------------------------------------------------------------*
//Last Modified: 2015.10.16
//*------------------------------------------------------------------*
int   TriesCount  = 5; 
int   _Pause      = 500;
//*------------------------------------------------------------------*
void GetTradeSymbol(string& TradeSymbol) 
{ 
   if(TradeSymbol=="") TradeSymbol=Symbol(); 
}
//*------------------------------------------------------------------*
double GetPoint(string TradeSymbol = "")
{
   GetTradeSymbol(TradeSymbol);
   if(StringFind(TradeSymbol,"XAU")>-1 || StringFind(TradeSymbol,"xau")>-1) return(0.1);  //Gold
   if(MarketInfo(TradeSymbol,MODE_DIGITS)==2 || MarketInfo(TradeSymbol,MODE_DIGITS)==3) return(0.01);
   if(MarketInfo(TradeSymbol,MODE_DIGITS)==4 || MarketInfo(TradeSymbol,MODE_DIGITS)==5) return(0.0001);
   if(MarketInfo(TradeSymbol,MODE_DIGITS)==0) return(1); //Indexes
   return(0.0001);
}
//*------------------------------------------------------------------*
double nd(double value, string TradeSymbol="")
{
   GetTradeSymbol(TradeSymbol);
   return(NormalizeDouble(value,(int)MarketInfo(TradeSymbol,MODE_DIGITS)));
}
//*------------------------------------------------------------------*
bool isDouble(double value)
{
   if(value==0) return(true);
   else return(value-MathFloor(value)>0);      
}
//*------------------------------------------------------------------*
double GetSpread(string TradeSymbol = "")
{
   GetTradeSymbol(TradeSymbol);
   double spread = MathCeil(MarketInfo(TradeSymbol,MODE_SPREAD));
   if(MarketInfo(TradeSymbol,MODE_DIGITS)==5 || MarketInfo(TradeSymbol,MODE_DIGITS)==3) return(spread/10);
   return(spread);
}
//*------------------------------------------------------------------*
int MinimumLimit(string TradeSymbol="")
{
   GetTradeSymbol(TradeSymbol);
   int minimum_sl = (int)MarketInfo(TradeSymbol,MODE_STOPLEVEL);
   if(MarketInfo(TradeSymbol,MODE_DIGITS)==5 || MarketInfo(TradeSymbol,MODE_DIGITS)==3) minimum_sl = minimum_sl/10;
   minimum_sl = minimum_sl + (int)GetSpread();
   return(minimum_sl);
}
//*------------------------------------------------------------------*
int NearestPending(string TradeSymbol = "")
{
   GetTradeSymbol(TradeSymbol);
   int near = (int) MarketInfo(TradeSymbol,MODE_STOPLEVEL);
   if(MarketInfo(TradeSymbol,MODE_DIGITS)==5 || MarketInfo(TradeSymbol,MODE_DIGITS)==3) near = near/10;
   return(near);
}
//*------------------------------------------------------------------*
double GetTakeProfit(int TradeType, double _TakeProfit, double _OpenPrice=0, string TradeSymbol="")
{
   if(_TakeProfit==0) return(0);
   
   GetTradeSymbol(TradeSymbol);
   
   if(isDouble(_TakeProfit)) return(nd(_TakeProfit,TradeSymbol));
   
   double _point = GetPoint(TradeSymbol);  
   double TP=0;
   
   switch(TradeType)
   {
      case OP_BUY:
      {
         TP = nd(MarketInfo(TradeSymbol,MODE_ASK)+_TakeProfit*_point,TradeSymbol);
         break;
      }
      case OP_SELL:
      {
         TP = nd(MarketInfo(TradeSymbol,MODE_BID)-_TakeProfit*_point,TradeSymbol);
         break;
      }
      case OP_BUYLIMIT:
      {
         if(_OpenPrice==0) TP = nd(MarketInfo(TradeSymbol,MODE_ASK)+_TakeProfit*_point,TradeSymbol);
         else TP = nd(_OpenPrice+_TakeProfit*_point,TradeSymbol);
         break;
      }
      case OP_BUYSTOP:
      {
         if(_OpenPrice==0) TP = nd(MarketInfo(TradeSymbol,MODE_ASK)+_TakeProfit*_point,TradeSymbol);
         else TP = nd(_OpenPrice+_TakeProfit*_point,TradeSymbol);
         break;
      }
      case OP_SELLLIMIT:
      {
         if(_OpenPrice==0) TP = nd(MarketInfo(TradeSymbol,MODE_BID)-_TakeProfit*_point,TradeSymbol);
         else TP = nd(_OpenPrice-_TakeProfit*_point,TradeSymbol);
         break;
      }
      case OP_SELLSTOP:
      {
         if(_OpenPrice==0) TP = nd(MarketInfo(TradeSymbol,MODE_BID)-_TakeProfit*_point,TradeSymbol);
         else TP = nd(_OpenPrice-_TakeProfit*_point,TradeSymbol);
         break;
      }
   }
   return(TP);
}
//*------------------------------------------------------------------*
double GetStopLoss(int TradeType, double _StopLoss, double _OpenPrice=0, string TradeSymbol="")
{
   if(_StopLoss==0) return(0);
   
   GetTradeSymbol(TradeSymbol);
   
   if(isDouble(_StopLoss)) return(nd(_StopLoss,TradeSymbol));
   
   double _point = GetPoint(TradeSymbol);  
   double SL=0;
   
   switch(TradeType)
   {
      case OP_BUY:
      {
         SL = nd(MarketInfo(TradeSymbol,MODE_ASK)-_StopLoss*_point,TradeSymbol);
         break;
      }
      case OP_SELL:
      {
         SL = nd(MarketInfo(TradeSymbol,MODE_BID)+_StopLoss*_point,TradeSymbol);
         break;
      }
      case OP_BUYLIMIT:
      {
         if(_OpenPrice==0) SL = nd(MarketInfo(TradeSymbol,MODE_ASK)-_StopLoss*_point,TradeSymbol);
         else SL = nd(_OpenPrice-_StopLoss*_point,TradeSymbol);
         break;
      }
      case OP_BUYSTOP:
      {
         if(_OpenPrice==0) SL = nd(MarketInfo(TradeSymbol,MODE_ASK)-_StopLoss*_point,TradeSymbol);
         else SL = nd(_OpenPrice-_StopLoss*_point,TradeSymbol);
         break;
      }
      case OP_SELLLIMIT:
      {
         if(_OpenPrice==0) SL = nd(MarketInfo(TradeSymbol,MODE_BID)+_StopLoss*_point,TradeSymbol);
         else SL = nd(_OpenPrice+_StopLoss*_point,TradeSymbol);
         break;
      }
      case OP_SELLSTOP:
      {
         if(_OpenPrice==0) SL = nd(MarketInfo(TradeSymbol,MODE_BID)+_StopLoss*_point,TradeSymbol);
         else SL = nd(_OpenPrice+_StopLoss*_point,TradeSymbol);
         break;
      }
   }
   return(SL);
}
//*------------------------------------------------------------------*
double GetOpenPrice(int TradeType, double price=0, int level=0, string TradeSymbol="")
{
   GetTradeSymbol(TradeSymbol);
   
   double _point = GetPoint(TradeSymbol);
   
   double _OpenPrice=0;
   
   switch(TradeType)
   {
      case OP_BUY:
      {
         _OpenPrice = nd(MarketInfo(TradeSymbol,MODE_ASK),TradeSymbol);
         break;
      }
      case OP_SELL:
      {
         _OpenPrice = nd(MarketInfo(TradeSymbol,MODE_BID),TradeSymbol);
         break;
      }
      case OP_BUYLIMIT:
      {
         if(price==0)
         {
            if(level==0) _OpenPrice = nd(MarketInfo(TradeSymbol,MODE_ASK),TradeSymbol);
            else _OpenPrice = nd(MarketInfo(TradeSymbol,MODE_ASK)-(level*_point),TradeSymbol);
         }
         else
         {
            if(level==0) _OpenPrice = nd(price,TradeSymbol);
            else _OpenPrice = nd(price-(level*_point),TradeSymbol);
         }
         break;
      }
      case OP_BUYSTOP:
      {
         if(price==0)
         {
            if(level==0) _OpenPrice = nd(MarketInfo(TradeSymbol,MODE_ASK),TradeSymbol);
            else _OpenPrice = nd(MarketInfo(TradeSymbol,MODE_ASK)+(level*_point),TradeSymbol);
         }
         else
         {
            if(level==0) _OpenPrice = nd(price,TradeSymbol);
            else _OpenPrice = nd(price+(level*_point),TradeSymbol);
         }
         break;
      }
      case OP_SELLLIMIT:
      {
         if(price==0)
         {
            if(level==0) _OpenPrice = nd(MarketInfo(TradeSymbol,MODE_BID),TradeSymbol);
            else _OpenPrice = nd(MarketInfo(TradeSymbol,MODE_BID)+(level*_point),TradeSymbol);
         }
         else
         {
            if(level==0) _OpenPrice = nd(price,TradeSymbol);
            else _OpenPrice = nd(price+(level*_point),TradeSymbol);
         }
         break;
      }
      case OP_SELLSTOP:
      {
         if(price==0)
         {
            if(level==0) _OpenPrice = nd(MarketInfo(TradeSymbol,MODE_BID),TradeSymbol);
            else _OpenPrice = nd(MarketInfo(TradeSymbol,MODE_ASK)-(level*_point),TradeSymbol);
         }
         else
         {
            if(level==0) _OpenPrice = nd(price,TradeSymbol);
            else _OpenPrice = nd(price-(level*_point),TradeSymbol);
         }
         break;
      }
   }
   
   return(_OpenPrice);
}
//*------------------------------------------------------------------*
bool isValidLimit(double limit_value, string limit_type, int order_type, string TradeSymbol="")
{
   if(limit_value==0) return(true);
   
   GetTradeSymbol(TradeSymbol);
   
   double distance=0,_point;
   _point = GetPoint(TradeSymbol);
   
   if(order_type==OP_BUY)
   {
      if(limit_type=="tp") distance = (limit_value - nd(MarketInfo(TradeSymbol,MODE_ASK)))/_point;
      if(limit_type=="sl") distance = (nd(MarketInfo(TradeSymbol,MODE_ASK))-limit_value)/_point;
   }
   if(order_type==OP_SELL)
   {
      if(limit_type=="sl") distance = (limit_value - nd(MarketInfo(TradeSymbol,MODE_BID)))/_point;
      if(limit_type=="tp") distance = (nd(MarketInfo(TradeSymbol,MODE_BID))-limit_value)/_point;
   } 
   if(distance<MinimumLimit(TradeSymbol)) return(false);
   return(true);
}
//*------------------------------------------------------------------*
int OpenPending(string TradeSymbol, double TradePrice, int TradeType, double TradeLot, int Level, int TradeSlippage=5, double TradeStopLoss=0, 
double TradeTakeProfit=0, int TradeMagicNumber=0, string TradeComment="", datetime Expiration=0, color ArrowColor=Yellow)
{
   GetTradeSymbol(TradeSymbol);
   
   if(TradePrice==0 && Level<NearestPending(TradeSymbol))
   {
      Print("Pending order distance is lesser than broker allowed distance!");
      return(-1);
   }
   
   if(TradeComment=="") TradeComment = WindowExpertName();
   
   double _openprice = GetOpenPrice(TradeType, TradePrice, Level, TradeSymbol);
   double _stoploss = GetStopLoss(TradeType, TradeStopLoss, _openprice, TradeSymbol);
   double _takeprofit = GetTakeProfit(TradeType, TradeTakeProfit, _openprice, TradeSymbol);
   
   int result=-1;     
   for(int cnt=0; cnt<TriesCount; cnt++)
   {                   
      result = OrderSend(TradeSymbol,TradeType,TradeLot,_openprice,TradeSlippage,_stoploss,_takeprofit,TradeComment,TradeMagicNumber,Expiration,ArrowColor);    
      if(result>-1) break; 
      else 
      {               
         Sleep(_Pause);
         if(cnt+1==TriesCount) PrintOrderOpenError("placing",TradeType,TradeSymbol,_openprice,_stoploss,_takeprofit,TradeLot);
      }  
   }         
      
   return(result);
}
//*------------------------------------------------------------------*
int OpenInstant(bool STP, string TradeSymbol, int TradeType, double TradeLot, int TradeSlippage=5, double TradeStopLoss=0, 
double TradeTakeProfit=0, int TradeMagicNumber=0, string TradeComment="", color ArrowColor=clrNONE)
{
   GetTradeSymbol(TradeSymbol);
   if(TradeComment=="") TradeComment = WindowExpertName();
   if(ArrowColor==clrNONE)
   {
      if(TradeType==OP_BUY) ArrowColor=clrBlue;
      else  ArrowColor=clrRed;
   }   
   
   double _openprice,  _stoploss, _takeprofit;
   int TradeTicket=-1;   
   for(int cnt=0; cnt<TriesCount; cnt++)
   {
      RefreshRates();
      _openprice = GetOpenPrice(TradeType, 0, 0, TradeSymbol);
      _stoploss = GetStopLoss(TradeType, TradeStopLoss, _openprice, TradeSymbol);
      _takeprofit = GetTakeProfit(TradeType, TradeTakeProfit, _openprice, TradeSymbol);
      
      if(!isValidLimit(_stoploss,"sl",TradeType,TradeSymbol) || !isValidLimit(_takeprofit,"tp",TradeType,TradeSymbol))
      {
         Print("Invalid limit");
         return(-1);
      }  
   
     
      if(_stoploss==0 && _takeprofit==0)
      {
         TradeTicket=OrderSend(TradeSymbol,TradeType,TradeLot,_openprice,TradeSlippage,0,0,TradeComment,TradeMagicNumber,0,ArrowColor);
         if(TradeTicket>-1) 
         {
            break;
         }
         else
         {
            if(cnt+1==TriesCount) PrintOrderOpenError("opening",TradeType,TradeSymbol,_openprice,_stoploss,_takeprofit,TradeLot);
            Sleep(_Pause);
         }
      }
      else
      {
         if(STP==false)
         {
            TradeTicket=OrderSend(TradeSymbol,TradeType,TradeLot,_openprice,TradeSlippage,_stoploss,_takeprofit,TradeComment,TradeMagicNumber,0,ArrowColor);
            if(TradeTicket>-1) break; 
         }
         else
         {
            TradeTicket=OrderSend(TradeSymbol,TradeType,TradeLot,_openprice,TradeSlippage,0,0,TradeComment,TradeMagicNumber,0,Red);
            if(TradeTicket>-1) 
            {
               if(!OrderSelect(TradeTicket,SELECT_BY_TICKET,MODE_TRADES)) continue;
               for(int i=0; i<TriesCount; i++)
               {
                  if(OrderModify(TradeTicket,OrderOpenPrice(),_stoploss,_takeprofit,0,ArrowColor)) 
                  break;
                  else
                  if(i+1==TriesCount) PrintOrderOpenError("modifying",TradeType,TradeSymbol,_openprice,_stoploss,_takeprofit,TradeLot);
               }
               break;
            }
            else
            {
               if(cnt+1==TriesCount) PrintOrderOpenError("opening",TradeType,TradeSymbol,_openprice,_stoploss,_takeprofit,TradeLot);
               Sleep(_Pause); 
            }
         }
      }
   }
      
   return(TradeTicket);
}
//*------------------------------------------------------------------*
bool ModifyInstant(int TradeTicket, double TradeStopLoss, double TradeTakeProfit)
{   
   if(!OrderSelect(TradeTicket,SELECT_BY_TICKET,MODE_TRADES)) return(false);   
   
   string TradeSymbol = OrderSymbol();
   
   double _point = GetPoint(TradeSymbol);
   
   bool result=false;      
   
   double SL=0,TP=0;
   if(isDouble(TradeStopLoss)) 
   {
      if(TradeStopLoss==0) SL = OrderStopLoss();
      else SL = TradeStopLoss;
   }
   else
   {
      if(OrderType()==OP_BUY) SL = nd(OrderOpenPrice()-TradeStopLoss*_point,TradeSymbol);
      if(OrderType()==OP_SELL) SL = nd(OrderOpenPrice()+TradeStopLoss*_point,TradeSymbol);
   }
   if(isDouble(TradeTakeProfit)) 
   {
      if(TradeTakeProfit==0) TP = OrderTakeProfit();
      else TP = TradeTakeProfit;
   }
   else
   {
      if(OrderType()==OP_BUY) TP = nd(OrderOpenPrice()+TradeTakeProfit*_point,TradeSymbol);
      if(OrderType()==OP_SELL) TP = nd(OrderOpenPrice()-TradeTakeProfit*_point,TradeSymbol);
   }
   
   for(int cnt=0; cnt<TriesCount; cnt++)
   {
      result = OrderModify(OrderTicket(),OrderOpenPrice(),SL,TP,0,Gold);
      if(result) break; else Sleep(_Pause);               
   }      
   
   return(result);
}
//*------------------------------------------------------------------*
int ModifyPending(int TradeTicket, double TradeOpenPrice, double TradeStopLoss, double TradeTakeProfit,  int TradeExpiration)
{
   if(!OrderSelect(TradeTicket,SELECT_BY_TICKET,MODE_TRADES)) return(false);
   
   string TradeSymbol = OrderSymbol();
   
   double _point = GetPoint(TradeSymbol);
      
   double SL=0,TP=0;
   if(isDouble(TradeStopLoss)) 
   {
      if(TradeStopLoss==0) SL = OrderStopLoss();
      else SL = TradeStopLoss;
   }
   else
   {
      if(OrderType()==OP_BUYLIMIT || OrderType()==OP_BUYSTOP)     SL = nd(OrderOpenPrice()-TradeStopLoss*_point,TradeSymbol);
      if(OrderType()==OP_SELLLIMIT || OrderType()==OP_SELLSTOP)   SL = nd(OrderOpenPrice()+TradeStopLoss*_point,TradeSymbol);
   }
   if(isDouble(TradeTakeProfit)) 
   {
      if(TradeTakeProfit==0) TP = OrderTakeProfit();
      else TP = TradeTakeProfit;
   }
   else
   {
      if(OrderType()==OP_BUYLIMIT || OrderType()==OP_BUYSTOP) TP = nd(OrderOpenPrice()+TradeTakeProfit*_point,TradeSymbol);
      if(OrderType()==OP_SELLLIMIT || OrderType()==OP_SELLSTOP) TP = nd(OrderOpenPrice()-TradeTakeProfit*_point,TradeSymbol);
   }
      
   
   bool result=false;   
   
   if(TradeOpenPrice==0) TradeOpenPrice = OrderOpenPrice();
   if(TradeExpiration==0) TradeExpiration = (int)OrderExpiration();
   
   for(int cnt=0; cnt<TriesCount; cnt++)
   {
      result = OrderModify(OrderTicket(),TradeOpenPrice,SL,TP,TradeExpiration,Gold);
      if(result) break; else Sleep(_Pause);               
   }      

   return(result);
}
//*------------------------------------------------------------------*
bool SetTrailingStop(int trail_start, int magic, string TradeSymbol="")
{
   if(trail_start==0) return(false);   
 
   GetTradeSymbol(TradeSymbol);
   
   bool result = false;   
   double _point = GetPoint(TradeSymbol);
   
   int cnt, i;
   for(cnt=0;cnt<OrdersTotal();cnt++) 
   {
      if(!OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES)) continue;
      if(OrderMagicNumber()!=magic) continue;
      
      if(iBarShift(NULL,0,OrderOpenTime())<BarsToActivate) continue;
      
      if(OrderType()==OP_SELL)  
      { 
         if(OrderOpenPrice()-MarketInfo(TradeSymbol,MODE_ASK)>_point*trail_start)
         {
            if(OrderStopLoss()>(MarketInfo(TradeSymbol,MODE_ASK)+_point*trail_start)+_point || OrderStopLoss()==0)
            {
               for(i=0; i<TriesCount; i++)
               {
                  RefreshRates();
                  result = OrderModify(OrderTicket(),OrderOpenPrice(),nd(MarketInfo(TradeSymbol,MODE_ASK)+_point*trail_start,TradeSymbol),OrderTakeProfit(),0,Gold);
                  if(result) break; 
                  else 
                  {                     
                     Sleep(_Pause);
                  }
               }
            }
         }
      }       

      if(OrderType()==OP_BUY)  
      { 
         if(MarketInfo(TradeSymbol,MODE_BID)-OrderOpenPrice()>_point*trail_start)
         {
            if(OrderStopLoss()<(MarketInfo(TradeSymbol,MODE_BID)-_point*trail_start)-_point || OrderStopLoss()==0)
            {
               for(i=0; i<TriesCount; i++)
               {
                  RefreshRates();
                  result = OrderModify(OrderTicket(),OrderOpenPrice(),nd(MarketInfo(TradeSymbol,MODE_BID)-_point*trail_start,TradeSymbol),OrderTakeProfit(),0,Gold);
                  if(result) break; 
                  else                
                  {
                     Sleep(_Pause);
                  }
               }
            }
         }
      }
   }
   
   return(result);
}
//*------------------------------------------------------------------*
bool SetTrailingStop(int trail_start, int trail_step, int trail_amount, int magic, string TradeSymbol="", color arrow_color=clrYellow)
{
   if(trail_start==0 || trail_step==0) return(false);   
   if(trail_amount==0) trail_amount = trail_step;
 
   GetTradeSymbol(TradeSymbol);   
   bool result = false;   
   double _point = GetPoint(TradeSymbol);
   
   int NextStep=0;
   double OnStopProfit=0, TradeProfit;
   int cnt, i;
   for(cnt=0;cnt<OrdersTotal();cnt++) 
   {
      if(!OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES)) continue;
      if(OrderMagicNumber()!=magic) continue;
      
      TradeProfit = Profit(OrderType(),OrderOpenPrice());
      
      if(OrderType()==OP_BUY && OrderStopLoss())
      OnStopProfit = (OrderStopLoss()-OrderOpenPrice())/_point;
      if(OrderType()==OP_SELL && OrderStopLoss()>0)
      OnStopProfit = (OrderOpenPrice()-OrderStopLoss())/_point;  
      if(OnStopProfit>0)     
      NextStep = int(OnStopProfit/trail_amount);
      if(NextStep<0) NextStep=0;
      
      if(TradeProfit>=trail_start+NextStep*trail_step)      
      {
         if(OrderType()==OP_BUY)
         {            
            for(i=0; i<TriesCount; i++)
            {
               if(OnStopProfit<0)
               result = OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+trail_amount*_point,OrderTakeProfit(),0,arrow_color); 
               else
               result = OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss()+trail_amount*_point,OrderTakeProfit(),0,arrow_color); 
               if(result) break; else Sleep(_Pause);              
            } 
         }
         if(OrderType()==OP_SELL)
         {            
            for(i=0; i<TriesCount; i++)
            {
               if(OnStopProfit<0)
               result = OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-trail_amount*_point,OrderTakeProfit(),0,arrow_color); 
               else
               result = OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss()-trail_amount*_point,OrderTakeProfit(),0,arrow_color);
               if(result) break; else Sleep(_Pause);               
            } 
         }
      }      
   }
    
   
   return(result);
}
//*------------------------------------------------------------------*
bool SetBreakEven(int break_even_at, int break_even_amount, int magic, string TradeSymbol="", color arrow_color=clrYellow)
{
   if(break_even_at==0) return(false);
   
   GetTradeSymbol(TradeSymbol);
   
   if(break_even_at<MinimumLimit(TradeSymbol))
   {
      PrintOnce("Breakeven distance is lesser than broker allowed distance!",0);
      return(false);
   }
   
   int cnt,i;
   bool result=false;
   double _profit=0;
   double _point = GetPoint(TradeSymbol);
   
   for(cnt=0; cnt<OrdersTotal(); cnt++)
   {
      if(!OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES)) continue;
      if(OrderMagicNumber()!=magic) continue;
             
      if(iBarShift(NULL,0,OrderOpenTime())<BarsToActivate) continue;
         
      if(OrderType()==OP_BUY) _profit = NormalizeDouble((((MarketInfo(TradeSymbol,MODE_BID)-OrderOpenPrice())/_point)),2); 
      if(OrderType()==OP_SELL) _profit = NormalizeDouble((((OrderOpenPrice()-MarketInfo(TradeSymbol,MODE_ASK))/_point)),2);
      
      if(_profit>=break_even_at)
      {
         if(OrderType()==OP_BUY && nd(OrderStopLoss())!=nd(OrderOpenPrice()+break_even_amount*_point) && 
         (OrderStopLoss()<OrderOpenPrice()+break_even_amount*_point || OrderStopLoss()==0))
         {
            for(i=0; i<TriesCount; i++)
            {
               result = OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+break_even_amount*_point,OrderTakeProfit(),0,arrow_color);   
               if(result) break; else Sleep(_Pause);    
            }         
            
         }
         if(OrderType()==OP_SELL && nd(OrderStopLoss())!=nd(OrderOpenPrice()-break_even_amount*_point) && 
         (OrderStopLoss()>OrderOpenPrice()-break_even_amount*_point || OrderStopLoss()==0))
         {
            for(i=0; i<TriesCount; i++)
            {
               result = OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-break_even_amount*_point,OrderTakeProfit(),0,arrow_color);   
               if(result) break; else Sleep(_Pause);    
            }         
         }
      }      
   }
   return(result);   
}
//*------------------------------------------------------------------*
void CloseAllFifo(int magic=0, int type=-1)
{
   int ticket=0;
   for(int cnt=0 ; cnt<=OrdersTotal(); cnt++)
   {
      ticket = GetOrder(magic, type, "");
      if(ticket==-1) break;
      else CloseOrder(ticket);
   }
   Sleep(_Pause);
   for(int cnt=0 ; cnt<=OrdersTotal(); cnt++)
   {
      ticket = GetOrder(magic, type, "");
      if(ticket==-1) break;
      else CloseOrder(ticket);
   }
   Sleep(_Pause);
   for(int cnt=0 ; cnt<=OrdersTotal(); cnt++)
   {
      ticket = GetOrder(magic, type, "");
      if(ticket==-1) break;
      else CloseOrder(ticket);
   }
   Sleep(_Pause);
   for(int cnt=0 ; cnt<=OrdersTotal(); cnt++)
   {
      ticket = GetOrder(magic, type, "");
      if(ticket==-1) break;
      else CloseOrder(ticket);
   }   
}
//*------------------------------------------------------------------*
int GetOrder(int magic=0, int type=-1, string symbol="", string comment="", int profit=0, double lots=0)
{
   int last_tick=-1;
   datetime last_open_time=-1;
   
   for (int cnt=0; cnt<OrdersTotal(); cnt++)
   {
      if(!OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES)) continue;
      if(magic!=0) if(OrderMagicNumber()!=magic) continue;
      if(type!=-1 && type<7) if(OrderType()!=type) continue;
      if(type==7) if(OrderType()>OP_SELL) continue; //close instants only
      if(type==8) if(OrderType()<=OP_SELL) continue; //close pendings only
      if(symbol!="") if(StringFind(OrderSymbol(),symbol)==-1) continue;
      if(comment!="") if(StringFind(OrderComment(),comment)==-1) continue;
      if(profit==1) if(OrderProfit()<0) continue;
      if(profit==-1) if(OrderProfit()>0) continue;
      if(lots>0) if(OrderLots()<lots) continue;
      
      //FIFO
      if(OrderOpenTime()<last_open_time || last_open_time==-1) 
      {
         last_open_time=OrderOpenTime();
         last_tick=OrderTicket();
      }
   }
   return(last_tick);
}
//*------------------------------------------------------------------*
bool CloseOrder(int TradeTicket, double lot=0, int slippage=5)
{   
   if(!OrderSelect(TradeTicket,SELECT_BY_TICKET,MODE_TRADES)) return(false);
   
   bool result=false;
   int cnt;
  
   if(OrderType()==OP_BUY)
   {
      for(cnt=0; cnt<TriesCount; cnt++)
      {
         RefreshRates();
         if(lot==0) result = OrderClose(OrderTicket(),OrderLots(),nd(MarketInfo(OrderSymbol(),MODE_BID),OrderSymbol()),slippage,Violet);
         else result = OrderClose(OrderTicket(),lot,nd(MarketInfo(OrderSymbol(),MODE_BID),OrderSymbol()),slippage,Violet);
         if(result) break; 
         else
         {
            Sleep(_Pause);               
         }
      }
   }
   if(OrderType()==OP_SELL)
   {
      for(cnt=0; cnt<TriesCount; cnt++)
      {
         RefreshRates();
         if(lot==0) result = OrderClose(OrderTicket(),OrderLots(),nd(MarketInfo(OrderSymbol(),MODE_ASK),OrderSymbol()),slippage,Violet);
         else result = OrderClose(OrderTicket(),lot,nd(MarketInfo(OrderSymbol(),MODE_ASK),OrderSymbol()),slippage,Violet);
         if(result) break; 
         else
         {
            Sleep(_Pause);               
         }
      }
   }
   if(OrderType()>OP_SELL)
   {
      for(cnt=0; cnt<TriesCount; cnt++)
      {
         result = OrderDelete(OrderTicket(),Violet);
         if(result) break; 
         else Sleep(_Pause);
      }
   }
   
   return(result);
}
//*------------------------------------------------------------------*
void CloseAll(int magic, string TradeSymbol="", int type=-1)
{
   GetTradeSymbol(TradeSymbol);
   int cnt;
   for(cnt=OrdersTotal()-1; cnt>=0; cnt--)
   {
      if(!OrderSelect(cnt,SELECT_BY_POS)) continue;
      if((OrderMagicNumber()==magic || magic==0) && OrderSymbol()==TradeSymbol)
      if(OrderType()==type || type==-1) 
      CloseOrder(OrderTicket());
   }
   Sleep(_Pause);
   for(cnt=OrdersTotal()-1; cnt>=0; cnt--)
   {
      if(!OrderSelect(cnt,SELECT_BY_POS)) continue;
      if((OrderMagicNumber()==magic || magic==0) && OrderSymbol()==TradeSymbol)
      if(OrderType()==type || type==-1) 
      CloseOrder(OrderTicket());
   }      
}
//*------------------------------------------------------------------*
double Profit(int type, double open, string TradeSymbol="", double lot=0.1, int option=2)
{
   GetTradeSymbol(TradeSymbol);
   
   double tick = MarketInfo(TradeSymbol,MODE_TICKVALUE);
   if(MarketInfo(TradeSymbol,MODE_DIGITS)==2 || MarketInfo(TradeSymbol,MODE_DIGITS)==4) tick=tick*0.1;

   double _point = GetPoint(TradeSymbol); 
   
   if(option==1) //Currency
   {
      if(type==OP_BUY) return(NormalizeDouble((((MarketInfo(TradeSymbol,MODE_BID) - open)/_point)*tick*(lot/0.1)),2)); 
      if(type ==OP_SELL) return(NormalizeDouble((((open - MarketInfo(TradeSymbol,MODE_ASK))/_point)*tick*(lot/0.1)),2));
   }
   
   if(option==2) //Points
   {
      if(type==OP_BUY) return(NormalizeDouble((((MarketInfo(TradeSymbol,MODE_BID) - open)/_point)),2)); 
      if(type ==OP_SELL) return(NormalizeDouble((((open - MarketInfo(TradeSymbol,MODE_ASK))/_point)),2));
   }
   return(0);
}
//*------------------------------------------------------------------*
double CalcLots(double Risk, double SL=0, double Balance=0, string TradeSymbol="")
{
   GetTradeSymbol(TradeSymbol);
   
   if(Balance==0) Balance = AccountBalance();
   
   double TickValue, tmpLot = 0, MinLot = 0, MaxLot = 0;
   MinLot = MarketInfo(TradeSymbol,MODE_MINLOT);
   MaxLot = MarketInfo(TradeSymbol,MODE_MAXLOT);
   
   TickValue = (MarketInfo(Symbol(),MODE_TICKVALUE)*GetPoint(TradeSymbol))/MarketInfo(Symbol(),MODE_TICKSIZE);
   
   int dig = 0;
   if(MarketInfo(TradeSymbol,MODE_LOTSTEP)==0.1) dig = 1;
   if(MarketInfo(TradeSymbol,MODE_LOTSTEP)==0.01) dig = 2;
   
   if(SL==0) //Risk only
   {
      tmpLot = NormalizeDouble(Balance*Risk/1000,dig);
   }
   else
   {
      double money_to_loss = Balance * Risk;    
      if(dig>0)
      {
         tmpLot = NormalizeDouble(money_to_loss/SL/TickValue,dig);      
      }
      else
      {
         double a = money_to_loss/SL/TickValue;
         double b = MarketInfo(TradeSymbol,MODE_LOTSTEP);
         int c = int(a/b);
         tmpLot = c*b;
      }
   }
   
   if(tmpLot < MinLot)
   {
      Print("LotSize is Smaller than the broker allow minimum Lot!");
      return(MinLot);
   } 
   if(tmpLot > MaxLot)
   {
      Print ("LotSize is Greater than the broker allow minimum Lot!");
      return(MaxLot);
   } 
   return(tmpLot);
}
//*------------------------------------------------------------------*
double ValidateLot(double lot, string TradeSymbol="")
{
   GetTradeSymbol(TradeSymbol);
   double tmpLot = 0, MinLot = 0, MaxLot = 0;
   int dig = 0;
   if(MarketInfo(TradeSymbol,MODE_LOTSTEP)==0.1) dig = 1;
   if(MarketInfo(TradeSymbol,MODE_LOTSTEP)==0.01) dig = 2;
   MinLot = MarketInfo(TradeSymbol,MODE_MINLOT);
   MaxLot = MarketInfo(TradeSymbol,MODE_MAXLOT);
   tmpLot = NormalizeDouble(lot,dig);
   if(tmpLot<MinLot)
   {
      Print("LotSize is Smaller than the broker allow minimum Lot!");
      return(NormalizeDouble(MinLot,dig));
   } 
   if(tmpLot>MaxLot)
   {
      Print("LotSize is Greater than the broker allow minimum Lot!");
      return(NormalizeDouble(MaxLot,dig));
   } 
   return(tmpLot);
}
//*------------------------------------------------------------------*
void PrintOrderOpenError(string task, int type, string TradeSymbol, double price, double stoploss, double takeprofit, double lots)
{  
   string sType;
   if(type==OP_BUY)  sType = "BUY"; if(type==OP_SELL) sType = "SELL";  
   if(type==OP_BUYSTOP)  sType = "BUY STOP"; if(type==OP_SELLSTOP) sType = "SELL STOP";  
   if(type==OP_BUYLIMIT)  sType = "BUY LIMIT"; if(type==OP_SELLLIMIT) sType = "SELL LIMIT";  
   int error = GetLastError();
   int digits = (int) MarketInfo(TradeSymbol,MODE_DIGITS);
   string msg = "Error " + task + " " + sType + " order!" + " Error = " + IntegerToString(error) + " (" + ErrorDescription(error) + ") ";
   msg = msg + " - Symbol=" + TradeSymbol + " - Price=" + DoubleToStr(price,digits) + " - StopLoss=" + DoubleToStr(stoploss,digits) 
   + " - TakeProfit=" + DoubleToStr(takeprofit,digits) + " - Lots=" + DoubleToStr(lots,2);
   Print(msg); 
}
//*------------------------------------------------------------------*
void PrintOnce(string msg, int ref=0)
{  
   static int LastPrint[5];
   
   if( LastPrint[ref] == 0 || LastPrint[ref] < Bars)
   {
      if(!IsTesting()) Print(msg);
      else Print("Print >> ",msg);
      LastPrint[ref] = Bars;
   }
}
//*------------------------------------------------------------------*

string ErrorDescription(int error_code)
{
   string error_string;
   
   switch(error_code)
   {
      //--- codes returned from trade server
      case 0:   error_string="no error";                                                   break;
      case 1:   error_string="no error, trade conditions not changed";                     break;
      case 2:   error_string="common error";                                               break;
      case 3:   error_string="invalid trade parameters";                                   break;
      case 4:   error_string="trade server is busy";                                       break;
      case 5:   error_string="old version of the client terminal";                         break;
      case 6:   error_string="no connection with trade server";                            break;
      case 7:   error_string="not enough rights";                                          break;
      case 8:   error_string="too frequent requests";                                      break;
      case 9:   error_string="malfunctional trade operation (never returned error)";       break;
      case 64:  error_string="account disabled";                                           break;
      case 65:  error_string="invalid account";                                            break;
      case 128: error_string="trade timeout";                                              break;
      case 129: error_string="invalid price";                                              break;
      case 130: error_string="invalid stops";                                              break;
      case 131: error_string="invalid trade volume";                                       break;
      case 132: error_string="market is closed";                                           break;
      case 133: error_string="trade is disabled";                                          break;
      case 134: error_string="not enough money";                                           break;
      case 135: error_string="price changed";                                              break;
      case 136: error_string="off quotes";                                                 break;
      case 137: error_string="broker is busy (never returned error)";                      break;
      case 138: error_string="requote";                                                    break;
      case 139: error_string="order is locked";                                            break;
      case 140: error_string="long positions only allowed";                                break;
      case 141: error_string="too many requests";                                          break;
      case 145: error_string="modification denied because order is too close to market";   break;
      case 146: error_string="trade context is busy";                                      break;
      case 147: error_string="expirations are denied by broker";                           break;
      case 148: error_string="amount of open and pending orders has reached the limit";    break;
      case 149: error_string="hedging is prohibited";                                      break;
      case 150: error_string="prohibited by FIFO rules";                                   break;
      //--- mql4 errors
      case 4000: error_string="no error (never generated code)";                           break;
      case 4001: error_string="wrong function pointer";                                    break;
      case 4002: error_string="array index is out of range";                               break;
      case 4003: error_string="no memory for function call stack";                         break;
      case 4004: error_string="recursive stack overflow";                                  break;
      case 4005: error_string="not enough stack for parameter";                            break;
      case 4006: error_string="no memory for parameter string";                            break;
      case 4007: error_string="no memory for temp string";                                 break;
      case 4008: error_string="non-initialized string";                                    break;
      case 4009: error_string="non-initialized string in array";                           break;
      case 4010: error_string="no memory for array\' string";                              break;
      case 4011: error_string="too long string";                                           break;
      case 4012: error_string="remainder from zero divide";                                break;
      case 4013: error_string="zero divide";                                               break;
      case 4014: error_string="unknown command";                                           break;
      case 4015: error_string="wrong jump (never generated error)";                        break;
      case 4016: error_string="non-initialized array";                                     break;
      case 4017: error_string="dll calls are not allowed";                                 break;
      case 4018: error_string="cannot load library";                                       break;
      case 4019: error_string="cannot call function";                                      break;
      case 4020: error_string="expert function calls are not allowed";                     break;
      case 4021: error_string="not enough memory for temp string returned from function";  break;
      case 4022: error_string="system is busy (never generated error)";                    break;
      case 4023: error_string="dll-function call critical error";                          break;
      case 4024: error_string="internal error";                                            break;
      case 4025: error_string="out of memory";                                             break;
      case 4026: error_string="invalid pointer";                                           break;
      case 4027: error_string="too many formatters in the format function";                break;
      case 4028: error_string="parameters count is more than formatters count";            break;
      case 4029: error_string="invalid array";                                             break;
      case 4030: error_string="no reply from chart";                                       break;
      case 4050: error_string="invalid function parameters count";                         break;
      case 4051: error_string="invalid function parameter value";                          break;
      case 4052: error_string="string function internal error";                            break;
      case 4053: error_string="some array error";                                          break;
      case 4054: error_string="incorrect series array usage";                              break;
      case 4055: error_string="custom indicator error";                                    break;
      case 4056: error_string="arrays are incompatible";                                   break;
      case 4057: error_string="global variables processing error";                         break;
      case 4058: error_string="global variable not found";                                 break;
      case 4059: error_string="function is not allowed in testing mode";                   break;
      case 4060: error_string="function is not confirmed";                                 break;
      case 4061: error_string="send mail error";                                           break;
      case 4062: error_string="string parameter expected";                                 break;
      case 4063: error_string="integer parameter expected";                                break;
      case 4064: error_string="double parameter expected";                                 break;
      case 4065: error_string="array as parameter expected";                               break;
      case 4066: error_string="requested history data is in update state";                 break;
      case 4067: error_string="internal trade error";                                      break;
      case 4068: error_string="resource not found";                                        break;
      case 4069: error_string="resource not supported";                                    break;
      case 4070: error_string="duplicate resource";                                        break;
      case 4071: error_string="cannot initialize custom indicator";                        break;
      case 4072: error_string="cannot load custom indicator";                              break;
      case 4073: error_string="no history data";                                           break;
      case 4074: error_string="not enough memory for history data";                        break;
      case 4075: error_string="not enough memory for indicator";                           break;
      case 4099: error_string="end of file";                                               break;
      case 4100: error_string="some file error";                                           break;
      case 4101: error_string="wrong file name";                                           break;
      case 4102: error_string="too many opened files";                                     break;
      case 4103: error_string="cannot open file";                                          break;
      case 4104: error_string="incompatible access to a file";                             break;
      case 4105: error_string="no order selected";                                         break;
      case 4106: error_string="unknown symbol";                                            break;
      case 4107: error_string="invalid price parameter for trade function";                break;
      case 4108: error_string="invalid ticket";                                            break;
      case 4109: error_string="trade is not allowed in the expert properties";             break;
      case 4110: error_string="longs are not allowed in the expert properties";            break;
      case 4111: error_string="shorts are not allowed in the expert properties";           break;
      case 4200: error_string="object already exists";                                     break;
      case 4201: error_string="unknown object property";                                   break;
      case 4202: error_string="object does not exist";                                     break;
      case 4203: error_string="unknown object type";                                       break;
      case 4204: error_string="no object name";                                            break;
      case 4205: error_string="object coordinates error";                                  break;
      case 4206: error_string="no specified subwindow";                                    break;
      case 4207: error_string="graphical object error";                                    break;
      case 4210: error_string="unknown chart property";                                    break;
      case 4211: error_string="chart not found";                                           break;
      case 4212: error_string="chart subwindow not found";                                 break;
      case 4213: error_string="chart indicator not found";                                 break;
      case 4220: error_string="symbol select error";                                       break;
      case 4250: error_string="notification error";                                        break;
      case 4251: error_string="notification parameter error";                              break;
      case 4252: error_string="notifications disabled";                                    break;
      case 4253: error_string="notification send too frequent";                            break;
      case 4260: error_string="ftp server is not specified";                               break;
      case 4261: error_string="ftp login is not specified";                                break;
      case 4262: error_string="ftp connect failed";                                        break;
      case 4263: error_string="ftp connect closed";                                        break;
      case 4264: error_string="ftp change path error";                                     break;
      case 4265: error_string="ftp file error";                                            break;
      case 4266: error_string="ftp error";                                                 break;
      case 5001: error_string="too many opened files";                                     break;
      case 5002: error_string="wrong file name";                                           break;
      case 5003: error_string="too long file name";                                        break;
      case 5004: error_string="cannot open file";                                          break;
      case 5005: error_string="text file buffer allocation error";                         break;
      case 5006: error_string="cannot delete file";                                        break;
      case 5007: error_string="invalid file handle (file closed or was not opened)";       break;
      case 5008: error_string="wrong file handle (handle index is out of handle table)";   break;
      case 5009: error_string="file must be opened with FILE_WRITE flag";                  break;
      case 5010: error_string="file must be opened with FILE_READ flag";                   break;
      case 5011: error_string="file must be opened with FILE_BIN flag";                    break;
      case 5012: error_string="file must be opened with FILE_TXT flag";                    break;
      case 5013: error_string="file must be opened with FILE_TXT or FILE_CSV flag";        break;
      case 5014: error_string="file must be opened with FILE_CSV flag";                    break;
      case 5015: error_string="file read error";                                           break;
      case 5016: error_string="file write error";                                          break;
      case 5017: error_string="string size must be specified for binary file";             break;
      case 5018: error_string="incompatible file (for string arrays-TXT, for others-BIN)"; break;
      case 5019: error_string="file is directory, not file";                               break;
      case 5020: error_string="file does not exist";                                       break;
      case 5021: error_string="file cannot be rewritten";                                  break;
      case 5022: error_string="wrong directory name";                                      break;
      case 5023: error_string="directory does not exist";                                  break;
      case 5024: error_string="specified file is not directory";                           break;
      case 5025: error_string="cannot delete directory";                                   break;
      case 5026: error_string="cannot clean directory";                                    break;
      case 5027: error_string="array resize error";                                        break;
      case 5028: error_string="string resize error";                                       break;
      case 5029: error_string="structure contains strings or dynamic arrays";              break;
      default:   error_string="unknown error";
   }
   return(error_string);
}